//Do not edit! This file was generated by Unity-ROS MessageGeneration.
using System;
using System.Linq;
using System.Collections.Generic;
using System.Text;
using Unity.Robotics.ROSTCPConnector.MessageGeneration;

namespace RosMessageTypes.Server
{
    [Serializable]
    public class MouthtargetGoal : Message
    {
        public const string k_RosMessageName = "hlrc_server/mouthtargetGoal";
        public override string RosMessageName => k_RosMessageName;

        public float opening_left;
        public float opening_right;
        public float opening_center;
        public float position_left;
        public float position_center;
        public float position_right;

        public MouthtargetGoal()
        {
            this.opening_left = 0.0f;
            this.opening_right = 0.0f;
            this.opening_center = 0.0f;
            this.position_left = 0.0f;
            this.position_center = 0.0f;
            this.position_right = 0.0f;
        }

        public MouthtargetGoal(float opening_left, float opening_right, float opening_center, float position_left, float position_center, float position_right)
        {
            this.opening_left = opening_left;
            this.opening_right = opening_right;
            this.opening_center = opening_center;
            this.position_left = position_left;
            this.position_center = position_center;
            this.position_right = position_right;
        }

        public static MouthtargetGoal Deserialize(MessageDeserializer deserializer) => new MouthtargetGoal(deserializer);

        private MouthtargetGoal(MessageDeserializer deserializer)
        {
            deserializer.Read(out this.opening_left);
            deserializer.Read(out this.opening_right);
            deserializer.Read(out this.opening_center);
            deserializer.Read(out this.position_left);
            deserializer.Read(out this.position_center);
            deserializer.Read(out this.position_right);
        }

        public override void SerializeTo(MessageSerializer serializer)
        {
            serializer.Write(this.opening_left);
            serializer.Write(this.opening_right);
            serializer.Write(this.opening_center);
            serializer.Write(this.position_left);
            serializer.Write(this.position_center);
            serializer.Write(this.position_right);
        }

        public override string ToString()
        {
            return "MouthtargetGoal: " +
            "\nopening_left: " + opening_left.ToString() +
            "\nopening_right: " + opening_right.ToString() +
            "\nopening_center: " + opening_center.ToString() +
            "\nposition_left: " + position_left.ToString() +
            "\nposition_center: " + position_center.ToString() +
            "\nposition_right: " + position_right.ToString();
        }

#if UNITY_EDITOR
        [UnityEditor.InitializeOnLoadMethod]
#else
        [UnityEngine.RuntimeInitializeOnLoadMethod]
#endif
        public static void Register()
        {
            MessageRegistry.Register(k_RosMessageName, Deserialize, MessageSubtopic.Goal);
        }
    }
}
